<!doctype html public "-//w3c//dtd html 4.0 transitional//en">
<html>
<head>
   <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
   <meta name="GENERATOR" content="Mozilla/4.7 [en] (X11; I; Linux 2.2.10 i686) [Netscape]">
   <title>JFLA 2000</title>
</head>
<body bgcolor="#FFFFFF">

<center>
<h1>
JFLA 2000: relecture du papier 2</h1></center>
Numero du papier: 2
<p>Titre du papier: Un cadre pour la d&eacute;finition r&eacute;cursive
des structures de donn&eacute;es
<p>Auteurs: Jean-Louis Giavitto, Olivier Michel
<p>Nom du rapporteur : Maria Virginia Aponte
<p>Confiance en la note: 2
<p>Notation du papier: 4
<p>Commentaires aux auteurs:
<br>&nbsp;
<br>&nbsp;
<p>Quelques remarques:
<p>- Il manque la d&eacute;finition du symbole DEF ({\tt Def}) employ&eacute;
pour la premiere fois p. 6 et par la suite presque partout dans l'article.
<p>- p.6, D&eacute;finition 2: .. On dit que P est maximal s'il existe
un O \in OXS ... QU'est-ce que OXS?
<p>- Votre article est tres bien &eacute;crit mais il est tres technique,
du moins pour l'audience habituelle de cette conf&eacute;rence. En revanche,
vous parlez assez peu des applications qui sont evoqu&eacute;es dans l'introduction.
Je suggere d'alleger un peu la partie technique, disons, suffisamment pour
que les id&eacute;es g&eacute;nerales de votre demarche soient comprises.
En compl&eacute;ment, il serait fortement souhaitable que vous ajoutiez
une discussion sur les perspectives/difficult&eacute;s d'appliquer dans
au moins l'un des langages "motivants" mentionn&eacute;s dans l'introduction
(Caml ou Haskell).
<p>- peut-on utiliser votre approche pour la structure des listes?
<p>- Apres lecture de l'introduction on a l'impression que vous souhaitez
&eacute;tendre l'expressivit&eacute; des d&eacute;finitions r&eacute;cursives
des structures des donn&eacute;es dans les langages fonctionnels. Pour
&eacute;tendre r&eacute;ellement les moyens d'expression dans ces langages
il faudrait au moins continuer a` accepter ce qui l'est d&eacute;ja, et
cela impose, dans certains cas, l'utilisation d'une strat&eacute;gie d'&eacute;valuation
paresseuse. Cela amene tout de suite la question du m&eacute;lange de celle-ci
avec votre approche. Que pouvez-vous en dire?
<p>Commentaires reserves au comite de programme:
<br>&nbsp;
<br>&nbsp;
<p><u>a. Resum&eacute; comment&eacute;:</u>
<p><u>Motivation</u>
<p>Les langages fonctionnels tels que Caml permettent la d&eacute;finition
r&eacute;cursive de structures des donn&eacute;es potentiellement infinies.
Alors que dans Caml leur expressivite est tres restrainte (pas d'appel
de fonctions pour les sous-calculs des &eacute;l&eacute;ments) pour &eacute;viter
le d&eacute;finition d'objets partiels (qui bouclent), d'autres langages
(p.e. Haskell) ont des moyens d'expressions plus riches mais qui ne garantissent
pas la terminaison a` l'&eacute;valuation.
<p>Les auteurs souhaitent:
<p>- determiner, a` la compilation, si une d&eacute;finition r&eacute;cursive
conduira a` une &eacute;valuation qui termine ou qui diverge, les dernieres
seront rejet&eacute;es par le compilateur,
<p>- pas d'intention d'adopter une strategie d'&eacute;valuation paresseuse,
<p>- dans le cas d'une structure dont l'&eacute;valuation est assur&eacute;e
de terminer, trouver l'ordre dans lesquel devront s'effectuer les sous-calculs
des sous-parties de la structure. Question: cela implique que les d&eacute;finitions
r&eacute;cursives des structures infinies (p.e. celles qu'on peut definir
en Caml) ne seront pas accept&eacute;es?
<p>- "compiler" l'&eacute;valuation des structures des donn&eacute;s qui
ne divergent pas.
<p>- r&eacute;aliser une inf&eacute;rence de types pour des types plus
riches (p.e. avec la dimension des vecteurs), cela est n&eacute;cessaire
pour resoudre les systemes d'&eacute;quations obtenus a` partir des d&eacute;finitions
r&eacute;cursives.
<p><u>Le cadre formel:</u>
<p>Les auteurs d&eacute;veloppent un cadre formel avec maintes d&eacute;finitions
math&eacute;matiques g&eacute;n&eacute;rales. Par la suite, il instancient
et pr&eacute;cisent ces d&eacute;finitions pour un exemple de langage pour
la d&eacute;finition r&eacute;cursives de vecteurs.
<p>La formalisation est assez technique. Voici un resume de ce que j'ai
compris. Des d&eacute;finitions math&eacute;matiques sont donn&eacute;es
pour les notions de:
<p>* type, structure et sous-structure des donn&eacute;es,
<p>* d&eacute;finition r&eacute;cursive d'une structure de donn&eacute;es
et son point fixe,
<p>* maximalit&eacute; d'un programme, calculabilit&eacute; d'un programme
par pr&eacute;fixe
<p>* progressivit&eacute; d'un programme
<p>L'id&eacute;e g&eacute;n&eacute;rale est d'&eacute;tablir un ensemble
d'&eacute;quations P~ a` partir d'un programme P qui d&eacute;finit une
structure r&eacute;cursive. On type ce programme par un moyen qui d&eacute;pend
de la nature des &eacute;quations. Si le programme est typable on cherche
a` montrer si sa solution peut etre calcul&eacute;e par pr&eacute;fixe,
a` savoir, en n'utilisant que des sous-structures de la structure de d&eacute;part.
Pour cela il suffit de montrer que le programme est progressif. Si un programme
est progressif, alors le calcul de sa solution ne diverge pas et il est
calculable par pr&eacute;fixe.
<p><u>Le cas des vecteurs</u>
<p>Ici les auteurs appliquent et pr&eacute;cisent leurs d&eacute;finitions
au cas des vecteurs. On se base sur un langage assez expressif pour la
d&eacute;finition d'&eacute;quations r&eacute;cursives sur les vecteurs.
<p>On d&eacute;finit les notions de:
<p>* Inf&eacute;rence de types pour les vecteurs:
<p>- le type d'un vecteur est sa longeueur
<p>- a partir du systeme d'&eacute;quations P~ engendr&eacute; par P, on
d&eacute;finit
<p>un ensemble d'&eacute;quations pour la restriction des variables de
<p>longueur associ&eacute;es a` chacune des sous-expression du programme
<p>- si une solution pour cet ensemble existe alors le programme
<p>est typable, i.e, on sait calculer la longeur de la solution.
<p>* Fonction de croissance associ&eacute;e au programme, programme progressif,
et d&eacute;finition d'une fonction PROG par cas sur les &eacute;quations
et sous-expressions du systeme. Ce programme permet la generation d'un
code imp&eacute;ratif qui calcule les vecteurs solutions du systeme par
une serie de boucles d'it&eacute;rations.
<p><u>Realisations</u>
<p>Toutes ces d&eacute;fintions ainsi que les calculs associ&eacute;s (typage,
point fixe, fonction progressive, etc. et (surtout!) code imp&eacute;ratif)
sont mis en oeuvre dans un notebook Mathematica.
<p>Le dernier point correspond a` l'objectif initial des auteurs quant
a` la compilation du calcul de la solution de la d&eacute;finition r&eacute;cursive.
<p><u>Originalite</u>
<p>Les auteurs affirment que c'est leur notion de calcul par pr&eacute;fixe
et de progressivite d'un programme qui est plus fine que les notions apparent&eacute;es
developp&eacute;es par ailleurs. Leur notion permettrait d'isoler une famille
de d&eacute;finitions r&eacute;cursives dont on peut compiler le calcul
de solution par un moyen simple, i.e, en se servant uniquement d'un ordonnancement
des sous-calculs li&eacute;s aux sous-structures des donn&eacute;es de
la defintion de depart.
<p><u>Forme et clart&eacute;</u>
<p>L'article est assez bien ecrit, structur&eacute; et motive. Il manque
cependant la definition d'une notion qui est employ&eacute;e presque partout
(peut-etre une notion classique dans le domaine, que je ne connais pas
du tout?).
<p><u>Evaluation</u>
<p>* L'article est assez technique mais suffisamment bien &eacute;crit
et motiv&eacute; pour qu'on capture les notions essentielles.
<p>* La g&eacute;neration du code compil&eacute; pour le cas des vecteurs
est un argument fort pour l'acceptation de l'article. Ind&eacute;niablement
le sujet peut trouver des applications de grande utilit&eacute; dans les
langages de programmation fonctionnel.
<p>* Cependant quelques points m'inquietent:
<p>- le d&eacute;veloppement technique occupe une partie consid&eacute;rable
de l'article et je ne suis absolument pas competente pour juger, ni sa
correction ni son originalite dans le domaine,
<p>- en dehors de quelques phrases sur la r&eacute;alisation en Mathematica,
les auteurs n'abordent absolument pas la question sur les applications
&eacute;ventuelles dans les langages fonctionnels. Ils ont pourtant orient&eacute;
toutes les motivations de l'introduction dans ce sens, en pr&eacute;sentant
que des exemples issus de Caml et Haskell,
<p>- un des exemples de l'introduction porte sur la d&eacute;finition d'une
liste infinie dont la solution est calculable, mais qui est rejet&eacute;e
par Caml. Je n'ai pas l'impression que leur formalisation traite ce cas,
ni meme le cas des listes infinies calculables a` la demande. Or, ils se
proposent en particulier d'etendre l'expressivit&eacute; de ces langages
(ou du moins, on peut l'esperer apres lecture de l'introduction). Sans
doute cela tient au fait qu'ils ne se placent pas dans un contexte d'&eacute;valuation
paresseuse. Cependant pour faire une extension conservative du pouvoir
expressif des structures r&eacute;cursives dans ces langages il faut un
jour ou l'autre se poser la question du m&eacute;lange entre leur approche
et l'&eacute;valuation paresseuse.
<p><u>Ma conclusion est:</u>
<p>Les applications potentielles sont tres inter&eacute;ssantes, et l'article
est suffisament bien &eacute;crit malgr&eacute; sa technicit&eacute; pour
que l'on comprenne grosso modo. Je conseille d'accepter l'article en demandant
&eacute;ventuellement aux auteurs d'all&eacute;ger la partie technique
(c'est qui du coup nous &eacute;vite de nous tracasser avec des problemes
de pertinence et d'originialit&eacute; sur ce point la) et de compl&eacute;ter
avec une discussion des applications dans les langages fonctionnels.
</body>
</html>
